#date：2021.12.25
#author:wjl
#aim:爬取google图片

from mimetypes import init
from selenium import webdriver
import time
import os
from getpic.crawl_image import CrawlImage
import requests
from urllib.parse import quote

# 使用代理的方法 ，可以直接windows使用代理，不用这么麻烦
# browserOptions = webdriver.ChromeOptions()
# browserOptions.add_argument('--proxy-server=ip:port)
# browser = webdriver.Chrome(chrome_options=browserOptions)

class CrawlImageFromGoogle(CrawlImage):
    # 初始化
    def __init__(self):
        super().__init__()
        self.browser = self.init_browser()

    # 获得Chrome驱动，并访问url
    def init_browser(self):
        # chrome_options = webdriver.ChromeOptions()
        # chrome_options.add_argument("--disable-infobars")
        browser = webdriver.Chrome(executable_path="/Users/58/software/ch/chromedriver")
        # 访问url
        browser.get(self.url)
        # 最大化窗口，之后需要爬取窗口中所见的所有图片
        browser.maximize_window()
        return browser

    #下载图片
    def downloadPic(self,savedir, round=20):
        #picpath = './cat'
        # 路径不存在时创建一个
        #if not os.path.exists(picpath): os.makedirs(picpath)
        os.makedirs(savedir, exist_ok=True)
        # 记录下载过的图片地址，避免重复下载
        img_url_dic = []

        count = 0 #图片序号
        pos = 0
        for i in range(round):
            pos += 500
            # 向下滑动
            js = 'var q=document.documentElement.scrollTop=' + str(pos)
            self.browser.execute_script(js)
            time.sleep(1)
            # 找到图片
            # html = browser.page_source#也可以抓取当前页面的html文本，然后用beautifulsoup来抓取
            #直接通过tag_name来抓取是最简单的，比较方便

            img_elements = self.browser.find_elements_by_tag_name('img')
            #遍历抓到的webElement
            for img_element in img_elements:
                img_url = img_element.get_attribute('src')
                # 前几个图片的url太长，不是图片的url，先过滤掉，爬后面的
                if isinstance(img_url, str):
                    if len(img_url) <= 200:
                        #将干扰的goole图标筛去
                        if 'images' in img_url:
                            #判断是否已经爬过，因为每次爬取当前窗口，或许会重复
                            #实际上这里可以修改一下，将列表只存储上一次的url，这样可以节省开销，不过我懒得写了···
                            if img_url not in img_url_dic:
                                try:
                                    img_url_dic.append(img_url)
                                    if count<634:
                                        continue
                                    #下载并保存图片到当前目录下
                                    filename = os.path.join(savedir, "google_boody_{}.jpg".format(count))
                                    r = requests.get(img_url)
                                    with open(filename, 'wb') as f:
                                        f.write(r.content)
                                    count += 1
                                    print('this is '+str(count)+'st img')
                                    #防止反爬机制
                                    time.sleep(0.2)
                                except:
                                    print('failure')

    def run(self, savedir):
        self.downloadPic(savedir,200)#可以修改爬取的页面数，基本10页是100多张图片
        self.browser.close()
        print("爬取完成")


if __name__ == '__main__':
    savedir = r"data/"
    craw = CrawlImageFromGoogle()
    craw.run(savedir)

